﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.WebEdition;
using ThinkGeo.MapSuite.Core;

namespace WebApplication_AircraftBlink
{
    public partial class Aircraft : System.Web.UI.Page
    {
        static Proj4Projection _proj = new Proj4Projection();
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                #region LoadDefaultMap New
                wfMap.MapUnit = GeographyUnit.Meter;

                wfMap.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(200, 200, 227, 234));
                ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"C:\Data\MapData\Countries02.shp");
                worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.FromArgb(80, 181, 202, 185), 1F), new GeoSolidBrush(GeoColor.FromArgb(255, 255, 255, 255)));
                worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                //_proj.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
                //_proj.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                //_proj.Open();
                //worldLayer.FeatureSource.Projection = _proj;
                //worldLayer.RequireIndex = false;

                LayerOverlay worldOverlay = new LayerOverlay("World Map", false, TileType.SingleTile);
                worldOverlay.WrapDateline = ThinkGeo.MapSuite.WebEdition.WrapDatelineMode.WrapDateline;  
                worldOverlay.Layers.Add("worldLayer", worldLayer);
                worldOverlay.TransitionEffect = TransitionEffect.None;
                worldOverlay.IsBaseOverlay = true;
                wfMap.CustomOverlays.Add(worldOverlay);
                
                //wfMap.CurrentExtent = _proj.ConvertToExternalProjection(new RectangleShape(-100, 30, 60, -20));
                wfMap.CurrentExtent = new RectangleShape(-100, 30, 60, -20);
                #endregion

                #region BlinkAircraftDRLayer
                //InMemoryFeatureLayer imBlinkAircraft_DR = new InMemoryFeatureLayer();
                //imBlinkAircraft_DR.Open();
                //imBlinkAircraft_DR.Columns.Add(new FeatureSourceColumn("FlightID"));
                //imBlinkAircraft_DR.Close();

                //BlinkingTextStyle_DR blinkingTextStyle_DR = new BlinkingTextStyle_DR();
                //blinkingTextStyle_DR.FillBrushes.Add(new GeoSolidBrush(GeoColors.Red));
                //blinkingTextStyle_DR.FillBrushes.Add(new GeoSolidBrush(GeoColors.Green));
                //blinkingTextStyle_DR.FillBrushes.Add(new GeoSolidBrush(GeoColors.Blue));
                //blinkingTextStyle_DR.OverlappingRule = LabelOverlappingRule.AllowOverlapping;
                //blinkingTextStyle_DR.DuplicateRule = LabelDuplicateRule.UnlimitedDuplicateLabels;
                //imBlinkAircraft_DR.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(blinkingTextStyle_DR);
                //imBlinkAircraft_DR.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                //LayerOverlay blinkingOverlay_DR = new LayerOverlay("BlinkAircraftDROverlay") { AutoRefreshInterval = TimeSpan.FromMilliseconds(200) };
                //blinkingOverlay_DR.Tick += new EventHandler<EventArgs>(markerOverlay_Tick);
                //blinkingOverlay_DR.Layers.Add("BlinkAircraftDRLayer", imBlinkAircraft_DR);
                //wfMap.CustomOverlays.Add(blinkingOverlay_DR);

                //Feature fAircraft = new Feature(new PointShape(10, 10));
                //fAircraft.ColumnValues.Add("FlightID", "A");
                //imBlinkAircraft_DR.InternalFeatures.Add(fAircraft.Id, fAircraft);
                #endregion
            }
        }

        static bool isBlinkAircraftActive = false;
        void markerOverlay_Tick(object sender, EventArgs e)
        {
            if (wfMap.CustomOverlays.Contains("BlinkAircraftDROverlay"))
            {
                InMemoryFeatureLayer imBlinkAircraft_DR = (InMemoryFeatureLayer)((LayerOverlay)wfMap.CustomOverlays["BlinkAircraftDROverlay"]).Layers["BlinkAircraftDRLayer"];
                imBlinkAircraft_DR.IsVisible = true;

                if (!isBlinkAircraftActive)
                {
                    isBlinkAircraftActive = true;
                    imBlinkAircraft_DR.ZoomLevelSet.ZoomLevel01.CustomStyles[0].IsActive = true;
                }
                else
                {
                    isBlinkAircraftActive = false;
                    imBlinkAircraft_DR.ZoomLevelSet.ZoomLevel01.CustomStyles[0].IsActive = false;
                }
                ((LayerOverlay)wfMap.CustomOverlays["BlinkAircraftDROverlay"]).Redraw();
            }
        }
    }
}